-module(action_bind).
% author Maxim Sokhatsky

-include_lib("nitro/include/nitro.hrl").
-include_lib("nitro/include/event.hrl").

-export([render_action/1]).


render_action(#bind{postback=Code, target={g, _}=Control, type=Type, source=Src}) ->
  % rebind same control to same handler on same target
  [" {if('", nitro:to_binary(Src), "' in ", wf_event:target(Control), "){",
    wf_event:target(Control), ".removeEventListener('", nitro:to_binary(Type), "',", nitro:to_binary(Src), ");"
    "delete ", wf_event:target(Control), "[", nitro:to_binary(Src), "]};",
    nitro:to_binary(Src), "={handleEvent:(event) => { "
    "if(event.type === '", nitro:to_binary(Type), "'){", nitro:to_binary(Code), "}}};",
    wf_event:target(Control), ".addEventListener('", nitro:to_binary(Type), "',", nitro:to_binary(Src), ");",
    wf_event:target(Control), ".", nitro:to_binary(Src), "=", nitro:to_binary(Src), ";} "];

render_action(#bind{postback=Code, target=Control, type=Type}) ->
  ["{var x=", wf_event:target(Control), ";"
     "x && x.addEventListener('", nitro:to_binary(Type), "',"
     "function(event){", nitro:to_binary(Code),"});}"].

