-module(element_textbox).
% author Rusty Klophaus

-include_lib("nitro/include/nitro.hrl").

-export([render_element/1]).


render_element(Record) when Record#textbox.show_if == false ->
  [<<>>];

render_element(Record) -> 
  List = [
    {<<"id">>, Record#textbox.id},
    {<<"type">>, <<"text">>},
    {<<"maxlength">>, Record#textbox.maxlength},
    {<<"style">>, Record#textbox.style},
    {<<"name">>, Record#textbox.name},
    {<<"placeholder">>, Record#textbox.placeholder},
    {<<"value">>, Record#textbox.value},
    {<<"disabled">>, Record#textbox.disabled},
    {<<"autofocus">>, Record#textbox.autofocus},
    
    {<<"readonly">>,
      case Record#textbox.readonly of
        true -> "readonly";
        _ -> []
      end},
    
    {<<"required">>,
      case Record#textbox.required of
        true -> "required";
        _ -> []
      end}, 
    
    {<<"class">>, Record#textbox.class} | Record#textbox.data_fields
  ] ++
    case Record#textbox.disabled of
      [] -> [];
      _ -> [{<<"disabled">>, <<"disabled">>}]
    end,
  
  wf_tags:emit_tag(<<"input">>, nitro:render(Record#textbox.body), List).

