-module(wf_event).
% author Maxim Sokhatsky
% author Andrey Martemyanov

-include_lib("nitro/include/cx.hrl").
-include_lib("nitro/include/nitro.hrl").

-export([target/1, new/2, new/6, new/7]).


-record(ev, { module, msg, trigger, name }).

target({ps, {qa, _Id}=T, Ps}) ->
  ["var t=", target(T), ";t.map(ts => '", nitro:js_escape(Ps), "'.split('.')"
     ".reduce((a, p)=>(a&&a[p]?a[p]:null), ts)).filter(o=>o)"];
target({ps, Id, Ps}) ->
  ["var ts=", target(Id), ",ps = '", nitro:js_escape(Ps), "'.split('.')"
     ".reduce((a,p)=>(a&&a[p]?a[p]:null),ts); ps&&ps"];
target({qs, S}) ->
  ["qs('", nitro:js_escape(nitro:to_list(S)), "')"];
target({qa, S}) ->
  ["Array.from(qa('", nitro:js_escape(nitro:to_list(S)), "'))"];
target({g, T}) ->
  nitro:js_escape(nitro:to_list(T));
target(Id) ->
  ["qi('", nitro:js_escape(nitro:to_list(Id)), "')"].


new(bin, Data) ->
  <<"ws.send(enc(tuple(atom('bin'), bin('", (nitro:pickle(Data))/binary, "'))));">>.

new(P, E, D, N, Data, Source) -> new(P, E, D, N, Data, Source, <<>>).

new([], _, _, _, _, _, _) -> <<>>;
new(undefined, _, _, _, _, _, _) -> <<>>;
new(Postback, Element, Delegate, Name, Data, Source, Validation) ->
  Module = nitro:coalesce([Delegate, ?CTX#cx.module]),
  
  Event = #ev{name=Name, module=Module, msg=Postback, trigger=Element},
  erlang:list_to_binary(["{ if(validateSources([",
    join([nitro:to_list(S) || S <- Source, S =/= []]),
    "])){", nitro:to_binary(Validation),
    " ws.send(enc(tuple(atom('",
    nitro:to_binary(application:get_env(n2z, event, pickle)),
    "'),bin('", Element, "'),bin('", nitro:pickle(Event), "'),", Data, ")));"
    "}else console.log('Validation Error'); }"
  ]).


join([]) ->
  [];
join([E]) ->
  [$'|E] ++ [$'];
join([H|T]) ->
  [[$'|H] ++ [$']] ++ [ [$,, $'|E] ++ [$'] || E <- T ].

